﻿init python:
    class talents_class:
        def __init__(self, name, info = "",
                    icon = "talent/empty.png", dependency = None,
                    pos = None):
            self.name = name
            self.info = info
            self.icon = icon
            self.dependency = dependency
            self.pos = pos
    class talents_handler:
        def __init__(self, talents, points):
            self.talents = talents
            self.got = []
            self.points = points
        def unlock(self, t):
            if self.points:
                if t not in self.got:
                    if not t.dependency:
                        self.got.append(t)
                        self.points -= 1
                    else:
                        for i in t.dependency:
                            if i in self.got:
                                self.got.append(t)
                                self.points -= 1
                                break
                            else:
                                msg.msg("Requires: {}".format(i.name))
            else:
                msg.msg("No points left.")
default empty_tal = talents_class(
    name = "",
    info = "",
    icon = None,
    dependency = None,
    pos = None,
    )
default innocence_tal = talents_class(
    "Innocence",
    "Innocent by nature.",
    icon = "talent/innocence_tal.png",
    pos = (896,476),
    )

# mean
default mean_tal = talents_class(
    "Mean",
    "Become mean to others.",
    "talent/mean_tal.png",
    dependency = [innocence_tal],
    pos = (1090,418),
    )
default indifference_tal = talents_class(
    "Indifference",
    "You don't care about people's problem.",
    "talent/indifference_tal.png",
    dependency = [mean_tal],
    pos = (1039,232),
    )

default denial_tal = talents_class(
    "Denial",
    "Stand on the path of people and deny them freedom.",
    "talent/denial_tal.png",
    dependency = [mean_tal],
    pos = (1283,438),
    )
default maniacal_tal = talents_class(
    "Maniacal",
    "You're going mad.",
    "talent/maniacal_tal.png",
    dependency = [denial_tal],
    pos = (1470,360),
    )
default troll_tal = talents_class(
    "Troll",
    "Troll people with reporting them.",
    "talent/troll_tal.png",
    dependency = [maniacal_tal],
    pos = (1578,190),
    )

default petty_tal = talents_class(
    "Petty",
    "Hate people for everything.",
    "talent/petty_tal.png",
    dependency = [denial_tal],
    pos = (1194,626),
    )
default virtue_signalling_tal = talents_class(
    "Virtue signalling",
    "Publicly attack people and get your own infamous internet name.",
    "talent/virtue_signalling_tal.png",
    dependency = [petty_tal],
    pos = (1236,802),
    )
default run_away_tal = talents_class(
    "Run away",
    "Delete you social accounts and go to hiding.",
    "talent/run_away_tal.png",
    dependency = [virtue_signalling_tal],
    pos = (1411,866),
    )

# selfish
default selfish_tal = talents_class(
    "Selfish",
    "Put your needs up front.",
    "talent/selfish_tal.png",
    dependency = [innocence_tal],
    pos = (832,646),
    )
default advance_tal = talents_class(
    "Advance",
    "Go places and become somebody.",
    "talent/advance_tal.png",
    dependency = [selfish_tal],
    pos = (753,816),
    )

# kind
default kind_tal = talents_class(
    "Kind",
    "Sensitive to people's problems.",
    "talent/kind_tal.png",
    dependency = [innocence_tal],
    pos = (726,402),
    )
default thoughtful_tal = talents_class(
    "Thoughtful",
    "Be thoughtful about other.",
    "talent/thoughtful_tal.png",
    dependency = [kind_tal],
    pos = (556,518),
    )
default caring_tal = talents_class(
    "Caring",
    "Care.",
    "talent/caring_tal.png",
    dependency = [thoughtful_tal],
    pos = (492,348),
    )
default helpful_tal = talents_class(
    "Helpful",
    "Help other people.",
    "talent/helpful_tal.png",
    dependency = [caring_tal],
    pos = (413,168),
    )
default loving_tal = talents_class(
    "Loving",
    "Show lots of love.",
    "talent/loving_tal.png",
    dependency = [helpful_tal],
    pos = (246,81),
    )

default study_tal = talents_class(
    "Study",
    "Seek knowledge that benefits people.",
    "talent/study_tal.png",
    dependency = [thoughtful_tal],
    pos = (400,610),
    )
default outlook_tal = talents_class(
    "Outlook",
    "Get an outlook on the problems.",
    "talent/outlook_tal.png",
    dependency = [study_tal],
    pos = (230,546),
    )
default solution_tal = talents_class(
    "Solution",
    "Discover solution to problems.",
    "talent/solution_tal.png",
    dependency = [outlook_tal],
    pos = (102,714),
    )

default talents_1 = talents_handler(
    [
    innocence_tal,
    mean_tal, indifference_tal, denial_tal, maniacal_tal, troll_tal, petty_tal, virtue_signalling_tal, run_away_tal,
    selfish_tal, advance_tal,
    kind_tal, thoughtful_tal, caring_tal, helpful_tal, loving_tal, loving_tal, study_tal, outlook_tal, solution_tal,
    ], 12
    )

transform talent_fade(p):
    alpha 0
    pause p
    ease .4 alpha 1
screen talents(t = talents_1):
    modal True
    default selected = None
    add "#000c"
    add "talent/connections.png" at talent_fade(1)
    text "{} points left".format(t.points) at talent_fade(1.4) align 1.0,0.0 offset -40,40

    for i in t.talents:
        button:
            xysize 128,128 anchor 0.0,0.0
            # at btn
            if i.pos:
                pos i.pos
            if i not in t.got:
                background im.Sepia(i.icon)
            else:
                background i.icon
            action SetScreenVariable("selected", i), SelectedIf(i in t.got)

    if selected:
        vbox:
            yalign 0.0 yoffset 40
            frame:
                background "#fff2"
                vbox:
                    text selected.name
                    text selected.info
                    if selected.dependency:
                        text "Requires: {}".format(selected.dependency[0].name)
            if selected not in t.got:
                button:
                    text "train"
                    action Function(t.unlock, selected)
